//<html><pre>
/* ---------------------------------------------------------------------------------------------------------
    andand.java		_H̑g									ver. 2.00 (JDK 1.02)
    																	ueyama@infonet.co.jp  2002.01.05
    																	update: 2007.07.27
--------------------------------------------------------------------------------------------------------- */

import java.applet.Applet;
import java.awt.*;


public class andand extends Applet
{
	// Truth table:  0 = and-and  1 = or-and  2 = and-or  3 = or-or
	int	Tt[][][]={{{0,0,0,0,0},{0,0,1,0,0},{0,1,0,0,0},{0,1,1,1,0},{1,0,0,0,0},{1,0,1,0,0},{1,1,0,0,0},{1,1,1,1,1}},
				  {{0,0,0,0,0},{0,0,1,1,0},{0,1,0,1,0},{0,1,1,1,0},{1,0,0,0,0},{1,0,1,1,1},{1,1,0,1,1},{1,1,1,1,1}},
				  {{0,0,0,0,0},{0,0,1,0,0},{0,1,0,0,0},{0,1,1,1,1},{1,0,0,0,1},{1,0,1,0,1},{1,1,0,0,1},{1,1,1,1,1}},
				  {{0,0,0,0,0},{0,0,1,1,1},{0,1,0,1,1},{0,1,1,1,1},{1,0,0,0,1},{1,0,1,1,1},{1,1,0,1,1},{1,1,1,1,1}}};
	int			A=0, B=0, C=0, D=0, X=0;								// eMl
	int			N=0;													// ^l\\s
	int			M;														// Logic Mode
	int			Tx=440, Ty=18, Cx=0, Cy=90;
	Image		Img;
	
	public void init()
	{
		String	bg=getParameter("bgcolor");								// wiF̓ǂݍ
		int bgc=Integer.valueOf(bg,16).intValue();
		setBackground(new Color(bgc));
		M=Integer.parseInt(getParameter("mode"));						// Logic [h̓ǂݍ
		MediaTracker mt=new MediaTracker(this);
		Img=getImage(getCodeBase(), getParameter("figure"));			// gif t@C̓ǂݍ
		mt.addImage(Img, 0);
		try
		{
			mt.waitForID(0);
		}
		catch(InterruptedException e){};
	}
	
	public boolean inside(int x, int a, int b)
	{
		return (x<=Math.max(a,b) && x>=Math.min(a,b)) ? true:false;
	}
	
	public void dtob()
	{
		A=N/4%2; B=N/2%2; C=N%2;
		D=Tt[M][N][3];
		X=Tt[M][N][4];
		dsp_v();
	}
	
	public void dsp_g(int x, int y, int n, int c)						// }`╶̕\
	{
		int			w=0, h=0, ox=0, oy=0;
		switch(n)
		{
			case	 0:	w=56; h=46; ox=  0; oy= 0;	break;				// Gates
			case	 1:	w=15; h=21; ox=112; oy= 0;	break;				// '0' or '1' (black)
			case	 2:	w=12; h=16; ox=142; oy= 0;	break;				// '0' or '1' (gray or red)
			case	 3:	w=15; h=15; ox=112; oy=21;	break;				// 'A', 'B', 'C' and 'X'
			case	 4:	w=70; h=15; ox=188; oy=16;	break;				// '^l\'
		}
		Graphics gx=getGraphics();
		gx.clipRect(x,y,w,h);
		gx.clearRect(x,y,w,h);
		gx.drawImage(Img,x-(ox+c*w),y-oy,this);
		gx.dispose();
	}
	
	public void dsp_l(int x, int y, int w, int h, int n)				// H()̕\
	{
		int			ox=0, oy=0;
		switch(n)
		{
			case	0:	ox=0; oy=47;	break;							// 
			case	1:	ox=3; oy= 0;	break;							// 
		}
		Graphics gx=getGraphics();
		gx.clipRect(x,y,w,h);
		gx.drawImage(Img,x-ox,y-oy,this);
		gx.dispose();
	}
	
	public void dsp_v()													// f[^Ɛ^l\̕\
	{
		int i,j;
		dsp_g(Cx+ 35,Cy+ 0,1,A); dsp_g(Cx+ 35,Cy+32,1,B); dsp_g(Cx+35,Cy+58,1,C);	// '0' or '1'
		dsp_g(Cx+226,Cy+44,2,D+4); dsp_g(Cx+343,Cy+14,1,X);
		for(i=0;i<8;i++) for(j=0;j<5;j++) dsp_g(Tx+j*32+10,Ty+(i+1)*24+4,2,Tt[M][i][j]+((i==N)?2:0));	// ^l\
	}

	public void paint(Graphics g)
	{
		int i;
		dsp_g(Cx+247, Cy, 0, M/2); dsp_g(Cx+105, Cy+32, 0, M%2);				// Gates
		dsp_l(Cx+62,Cy+9,185,2,0); dsp_l(Cx+62,Cy+41,44,2,0); dsp_l(Cx+62,Cy+67,44,2,0);
		dsp_l(Cx+161,Cy+54,25,2,0); dsp_l(Cx+186,Cy+35,61,2,0); dsp_l(Cx+300,Cy+22,32,2,0);
		dsp_l(Cx+186,Cy+35,2,21,1);
		dsp_g(Cx, Cy+3, 3, 0); dsp_g(Cx, Cy+35, 3, 1); dsp_g(Cx, Cy+61, 3, 2);	// 'A', 'B', 'C'
		dsp_g(Cx+198, Cy+45, 3, 3); dsp_g(Cx+375, Cy+17, 3, 4);			// 'd' & 'X'
		g.setColor(new Color(102,102,102));								// ^l\ r̕\
		for(i=0;i<10;i++) g.drawLine(Tx,Ty+i*24,Tx+160,Ty+i*24);
		for(i=0;i<6;i++) g.drawLine(Tx+i*32,Ty,Tx+i*32,Ty+216);
		for(i=0;i<5;i++) dsp_g(Tx+i*32+7, Ty+5, 3, i);					// ^l\ M̕\
		dsp_g(Tx, Ty-18, 4, 0);											// '^l\' ̕\
		dsp_v();
	}
	
	public boolean mouseDown(Event e, int mx, int my)
	{
		int k=N;
		if(mx>Tx && my>Ty+24) N=(my-Ty-24)/24;							// ^l\NbN
		else if(mx-Cx<100)
		{
			if(inside(my,Cy+ 0,Cy+21)) A=(A==0)?1:0;					// A NbN
			if(inside(my,Cy+32,Cy+53)) B=(B==0)?1:0;					// B NbN
			if(inside(my,Cy+58,Cy+79)) C=(C==0)?1:0;					// C NbN
			N=A*4 + B*2 + C;
		}
		if(k!=N) dtob();
		return true;
	}
}
//</pre><a HREF="JavaScript:history.go(-1)">߂</A></html>
